import java.lang.*;
import java.awt.*;

public class Project3 extends java.applet.Applet {

    private Polygon q, l, u, qsmoothed;
    private Point current, loser;
    private boolean drawable, first, xerror, smoothed,animate;
    private Scrollbar sb;
    private Image  buffer;
    private Graphics bufg;
    private final int r=2;
    private Button qButton, cButton, coButton, iButton;
    private Panel pl, pl1;
    private int threshold=25;
    private Rectangle border, inner;
    private final String  ErrMsg = "ERROR: Polygonal chain MUST be monotonic in the x-direction";;
    private Font f;
    private Label lbl;
    
public void init()  {

  setBackground(Color.white);
  setLayout(new BorderLayout());
  pl = new Panel();
  pl1 = new Panel();
  lbl = new Label("Threshold = "+threshold +"Units");
  
  pl.add(cButton = new Button(" Clear All   ")) ;
  pl.add(coButton = new Button("  Compute   "));
  pl.add(iButton = new Button(" Clear New Chains"));
  sb = new Scrollbar(Scrollbar.HORIZONTAL);
  sb.setValues(25,10,0,110);
  pl1.setLayout( new FlowLayout(FlowLayout.LEFT));
  pl1.add(lbl);
  pl1.add(sb);
  add("North",pl1);
  add("South", pl);
  resize(500, 500);
  border = new Rectangle(0,0,size().width-1, size().height-1);
  inner= new Rectangle(r+1,r+1,size().width-2*r-23, size().height-2*r-23);
  f = new Font("Ariel", Font.BOLD, 12);
  buffer = createImage(size().width, size().height);
  bufg = buffer.getGraphics();
  bufg.setFont(getFont());
  reset();
  show();
}

public void update(Graphics g) {
  int px, py;
  if (! animate) {bufg.setColor(getBackground());
  bufg.fillRect(border.x,border.y,border.width,border.height); }
  bufg.setColor(Color.red);
  bufg.drawRect(border.x,border.y,border.width,border.height);

  if (q != null ) {
  px = q.xpoints[q.npoints-1];
  py = q.ypoints[q.npoints-1];
  if (current != null) 
    bufg.drawLine(px, py, current.x, current.y);
  if ((loser != null) && (current == null)) {
     g.setXORMode(getBackground());
     g.drawLine(px, py, loser.x, loser.y);
     g.setPaintMode();
     loser = null;
   }
  
  for(int i=0;i<q.npoints;i++) {bufg.setColor(Color.black);
    bufg.drawOval(q.xpoints[i]-r,q.ypoints[i]-r,2*r,2*r);
    bufg.setColor(Color.darkGray);
    bufg.fillOval(q.xpoints[i]-r,q.ypoints[i]-r,2*r,2*r);
    }
  bufg.setColor(Color.black);
  bufg.drawPolygon(q);
}
  if (l != null) {
  
  for(int i=0;i<l.npoints;i++) {bufg.setColor(Color.green);
    bufg.drawOval(l.xpoints[i]-r,l.ypoints[i]-r,2*r,2*r);
    bufg.setColor(Color.orange);
    bufg.fillOval(l.xpoints[i]-r,l.ypoints[i]-r,2*r,2*r);
    }
   bufg.setColor(Color.green);
  bufg.drawPolygon(l);
 }
  if (u != null) {
  
  for(int i=0;i<u.npoints;i++) {
  bufg.setColor(Color.blue);
    bufg.drawOval(u.xpoints[i]-r,u.ypoints[i]-r,2*r,2*r);
    bufg.setColor(Color.yellow);
    bufg.fillOval(u.xpoints[i]-r,u.ypoints[i]-r,2*r,2*r);
   }
   bufg.setColor(Color.blue);
  bufg.drawPolygon(u);
 }
 if (xerror) {
   bufg.setColor(Color.red);
   bufg.setFont(f);
   bufg.drawString(ErrMsg,25,size().height-75);
   bufg.drawString("Press <Clear>.....",25,size().height-50);
  }
  
 if (smoothed) {
   bufg.setColor(Color.red);
   for(int i=0;i<qsmoothed.npoints;i++) {
     bufg.drawOval(qsmoothed.xpoints[i]-r,qsmoothed.ypoints[i]-r,2*r,2*r);
     bufg.fillOval(qsmoothed.xpoints[i]-r,qsmoothed.ypoints[i]-r,2*r,2*r);
     }
   bufg.drawPolygon(qsmoothed);

  }
 g.drawImage(buffer, 0, 0, null);
}

public void paint(Graphics g) {
  
  update(g);
}



public void finish() {

   loser = current;
   current = null;
   drawable = false;
   coButton.enable();
   repaint();
}

public void reset() {

  current = loser= null;
  q=l=u=null;
  coButton.disable();
  iButton.disable();
  drawable = true;
  first=true;
  xerror = false;
  smoothed = animate =false;
  repaint();
}

public void computeTransform() {
    
    int t1, t2, t3; 

    l = new Polygon(q.xpoints, q.ypoints, q.npoints);
    u = new Polygon(q.xpoints, q.ypoints, q.npoints);
    for(int i = 0; i<q.npoints;i++)
     {
      l.ypoints[i] -= threshold;
      u.ypoints[i] += threshold;
     }
 
    repaint();      
}

public  void animateline(Polygon t) {

  int i,j;
  float m, b, c;
   Point p1, p2;
   
  
   i = t.npoints -1;
   j = i-1;
   p1 =  new Point(t.xpoints[j],t.ypoints[j]); 
   p2 = new Point(0,0);
   m = (float)(t.ypoints[i] - t.ypoints[j]) / (float)(t.xpoints[i] - t.xpoints[j]);
   bufg.setColor(Color.red);
   for(int p =t.xpoints[j]; p <= t.xpoints[i]; p++)
     {
       b = m*(p - t.xpoints[j]) + t.ypoints[j];
       p2.x = p; p2.y = Math.round(b);
       bufg.drawLine(p1.x,p1.y, p2.x,p2.y);
       System.out.println("Tallman");
       repaint(); 
    try { Thread.sleep(300); 
            }
         catch (Exception noSleep) {}
   
                  
       p1 = p2;
       
      }
  }
  
public void smoothing() {
  Point t1, t2, t3;
  int i,j,n;
  float m,b;
  // Polygon ipoints;
  boolean s,c;

  qsmoothed = new Polygon();
  t1 = new Point(u.xpoints[0], u.ypoints[0]);
  qsmoothed.addPoint(t1.x, t1.y);
  repaint();
  t3 = new Point(u.xpoints[u.npoints-1], t1.y);
  n = u.npoints;
  s=true;
  c=false;
  for(i=1;i<n;i++)
    {
       // animate = true;
       if (u.ypoints[i] == t1.y) {
	  qsmoothed.addPoint(u.xpoints[i], u.ypoints[i]);
	  // animateline(qsmoothed);
	  
	  s=true;
	  c=true;
         }
      if (l.ypoints[i] == t1.y) {
	  qsmoothed.addPoint(l.xpoints[i], l.ypoints[i]); // animateline(qsmoothed);
	  
	  s =false;
	  c=true;
         } 
       if ((u.ypoints[i] < t1.y) )
         if ((u.ypoints[i-1] > t1.y)){
	 m= (float)(u.ypoints[i] - u.ypoints[i-1]) / (float)(u.xpoints[i] - u.xpoints[i-1]);
	 b = (t1.y - u.ypoints[i-1])/m + u.xpoints[i-1];
	 qsmoothed.addPoint( Math.round(b), t1.y); 
	  // animateline(qsmoothed); 
	 qsmoothed.addPoint(u.xpoints[i],u.ypoints[i]); 
	  // animateline(qsmoothed);
	 s=true;
	 c=true;
       }
       else  {
         qsmoothed.addPoint(u.xpoints[i], u.ypoints[i]);
           // animateline(qsmoothed);
         c=true; s = true;
         }
       
       if ((l.ypoints[i] > t1.y))
         if ((l.ypoints[i-1] < t1.y)){
	 m= (float)(l.ypoints[i] - l.ypoints[i-1]) / (float)(l.xpoints[i] - l.xpoints[i-1]);
	 b = (float)(t1.y - l.ypoints[i-1])/m + (float)l.xpoints[i-1];
	 qsmoothed.addPoint(Math.round(b),t1.y);
	  //   animateline(qsmoothed);
	 qsmoothed.addPoint(l.xpoints[i],l.ypoints[i]);
	  // animateline(qsmoothed);
	 s=false;
	 c=true;  
       }
       else  {
         qsmoothed.addPoint(l.xpoints[i], l.ypoints[i]);
          // animateline(qsmoothed);
         c=true; s = false;
         }
       if ((s) && (c)) {
          t1.x = u.xpoints[i];
	  t1.y = u.ypoints[i];
	  t3.y = t1.y;
	 } 
       else if (c) {
         t1.x = l.xpoints[i];
	 t1.y = l.ypoints[i];
	 t3.y = t1.y;
	} 
	c=false;	 
     }
       qsmoothed.addPoint(t3.x,t3.y); // animateline(qsmoothed);
      
      // qsmoothed = new Polygon(qsmoothed.xpoints,qsmoothed.ypoints,qsmoothed.npoints);
      smoothed = true;
}

public boolean xmonotonic() {

   boolean left, right;
   Polygon temp;

   
left = right = true;

 for(int i =0; i<q.npoints-1;i++)
   if (q.xpoints[i] > q.xpoints[i+1])
     right = false;
 for(int i =0; i<q.npoints-1;i++)
   if (q.xpoints[i] < q.xpoints[i+1])
       left = false;
 if (left){
   temp =  new Polygon();
   for(int i=0;i<q.npoints;i++)
      temp.addPoint(q.xpoints[q.npoints-1-i],q.ypoints[q.npoints-1-i]);
   q = temp;
   }


 return (left || right);
}



public boolean handleEvent(Event evt) {
if (evt.target instanceof Button) {
   if (evt.target == cButton) {
     coButton.disable(); iButton.disable();
     reset();
    }
   else if (evt.target == coButton) {
      if (!xmonotonic()) { xerror = true; coButton.disable(); repaint();}
      else
       { computeTransform(); repaint();        
         smoothing();coButton.disable();
	 iButton.enable(); repaint();
       }
     }
    else if (evt.target == iButton) {u=l=qsmoothed = null;
    iButton.disable(); smoothed= animate=false; coButton.enable(); repaint();}
   return true;
    
    }
   
switch (evt.id) {
  case Event.MOUSE_MOVE: {if ((drawable) && inner.inside(evt.x,evt.y)) { 
  if (first) {
   current = new Point(evt.x,evt.y);
   loser = new Point(evt.x,evt.y);
   first = false;
   }
   current.move(evt.x,evt.y);
  repaint();
  break;}
  } 
  case Event.MOUSE_DOWN: { if ((drawable) && inner.inside(evt.x,evt.y)) {
  if (evt.modifiers == 0) {
    
    repaint();
    current.x = evt.x; current.y = evt.y;
    if (q == null)
      q = new Polygon();
      q.addPoint(evt.x,evt.y);
      repaint();
    }
    else
      finish();
    }
    break;}
      
  case Event.SCROLL_PAGE_UP: case Event.SCROLL_PAGE_DOWN:
  case Event.SCROLL_LINE_DOWN: case Event.SCROLL_LINE_UP:
  case Event.SCROLL_ABSOLUTE: {threshold = sb.getValue(); 
       lbl.setText("Threshold = "+threshold+"Units");
       break;}
  default: break;
  }
return true;
}


}
